# 对照表
import json

column_map = {
    "A": "c1",
    "B": "c2",
    "C": "c3",
    "D": "c4",
    "E": "c5",
    "F": "c6",
    "G": "c7",
    "H": "c8",
    "I": "c9",
    "J": "c10",
    "K": "c11",
    "L": "c12",
    "M": "c13",
    "N": "c14",
    "O": "c15",
    "P": "c16",
    "Q": "c17",
    "R": "c18",
    "S": "c19",
    "T": "c20",
    "U": "c21",
    "V": "c22",
    "W": "c23",
    "X": "c24",
    "Y": "c25",
    "Z": "c26",
    "AA": "c27",
    "AB": "c28",
    "AC": "c29",
    "AD": "c30",
    "AE": "c31",
    "AF": "c32",
    "AG": "c33",
    "AH": "c34",
    "AI": "c35",
    "AJ": "c36",
    "AK": "c37",
    "AL": "c38",
    "AM": "c39",
    "AN": "c40",
    "AO": "c41",
    "AP": "c42",
    "AQ": "c43",
    "AR": "c44",
    "AS": "c45",
    "AT": "c46",
    "AU": "c47",
    "AV": "c48",
    "AW": "c49",
    "AX": "c50",
    "AY": "c51",
    "AZ": "c52",
    "BA": "c53",
    "BB": "c54",
    "BC": "c55",
    "BD": "c56",
    "BE": "c57",
    "BF": "c58",
    "BG": "c59",
    "BH": "c60",
    "BI": "c61",
    "BJ": "c62",
    "BK": "c63",
    "BL": "c64",
    "BM": "c65",
    "BN": "c66",
    "BO": "c67",
    "BP": "c68",
    "BQ": "c69",
    "BR": "c70",
    "BS": "c71",
    "BT": "c72",
    "BU": "c73",
    "BV": "c74",
    "BW": "c75",
    "BX": "c76",
    "BY": "c77",
    "BZ": "c78",
    "CA": "c79",
    "CB": "c80",
    "CC": "c81",
    "CD": "c82",
    "CE": "c83",
    "CF": "c84",
    "CG": "c85",
    "CH": "c86",
    "CI": "c87",
    "CJ": "c88",
    "CK": "c89",
    "CL": "c90",
    "CM": "c91",
    "CN": "c92",
    "CO": "c93",
    "CP": "c94",
    "CQ": "c95",
    "CR": "c96",
    "CS": "c97",
    "CT": "c98",
    "CU": "c99",
    "CV": "c100",
    "CW": "c101",
    "CX": "c102",
    "CY": "c103",
    "CZ": "c104",
    "DA": "c105",
    "DB": "c106",
    "DC": "c107",
    "DD": "c108",
    "DE": "c109",
    "DF": "c110",
    "DG": "c111",
    "DH": "c112",
    "DI": "c113",
    "DJ": "c114",
    "DK": "c115",
    "DL": "c116",
    "DM": "c117",
    "DN": "c118",
    "DO": "c119",
    "DP": "c120",
    "DQ": "c121",
    "DR": "c122",
    "DS": "c123",
    "DT": "c124",
    "DU": "c125",
    "DV": "c126",
    "DW": "c127",
    "DX": "c128",
    "DY": "c129",
    "DZ": "c130",
    "EA": "c131",
    "EB": "c132",
    "EC": "c133",
    "ED": "c134",
    "EE": "c135",
    "EF": "c136",
    "EG": "c137",
    "EH": "c138",
    "EI": "c139",
    "EJ": "c140",
    "EK": "c141",
    "EL": "c142",
    "EM": "c143",
    "EN": "c144",
    "EO": "c145",
    "EP": "c146",
    "EQ": "c147",
    "ER": "c148",
    "ES": "c149",
    "ET": "c150",
    "EU": "c151",
    "EV": "c152",
    "EW": "c153",
    "EX": "c154",
    "EY": "c155",
    "EZ": "c156",
    "FA": "c157",
    "FB": "c158",
    "FC": "c159",
    "FD": "c160",
    "FE": "c161",
    "FF": "c162",
    "FG": "c163",
    "FH": "c164",
    "FI": "c165",
    "FJ": "c166",
    "FK": "c167",
    "FL": "c168",
    "FM": "c169",
    "FN": "c170",
    "FO": "c171",
    "FP": "c172",
    "FQ": "c173",
    "FR": "c174",
    "FS": "c175",
    "FT": "c176",
    "FU": "c177",
    "FV": "c178",
    "FW": "c179",
    "FX": "c180",
    "FY": "c181",
    "FZ": "c182",
    "GA": "c183",
    "GB": "c184",
    "GC": "c185",
    "GD": "c186",
    "GE": "c187",
    "GF": "c188",
    "GG": "c189",
    "GH": "c190",
    "GI": "c191",
    "GJ": "c192",
    "GK": "c193",
    "GL": "c194",
    "GM": "c195",
    "GN": "c196",
    "GO": "c197",
    "GP": "c198",
    "GQ": "c199",
    "GR": "c200",
    "GS": "c201",
    "GT": "c202",
    "GU": "c203",
    "GV": "c204",
    "GW": "c205",
    "GX": "c206",
    "GY": "c207",
    "GZ": "c208",
    "HA": "c209",
    "HB": "c210",
    "HC": "c211",
    "HD": "c212",
    "HE": "c213",
    "HF": "c214",
    "HG": "c215",
    "HH": "c216",
    "HI": "c217",
    "HJ": "c218",
    "HK": "c219",
    "HL": "c220",
    "HM": "c221",
    "HN": "c222",
    "HO": "c223",
    "HP": "c224",
    "HQ": "c225",
    "HR": "c226",
    "HS": "c227",
    "HT": "c228",
    "HU": "c229",
    "HV": "c230",
    "HW": "c231",
    "HX": "c232",
    "HY": "c233",
    "HZ": "c234",
    "IA": "c235",
    "IB": "c236",
    "IC": "c237",
    "ID": "c238",
    "IE": "c239",
    "IF": "c240",
    "IG": "c241",
    "IH": "c242",
    "II": "c243",
    "IJ": "c244",
    "IK": "c245",
    "IL": "c246",
    "IM": "c247",
    "IN": "c248",
    "IO": "c249",
    "IP": "c250",
    "IQ": "c251",
    "IR": "c252",
    "IS": "c253",
    "IT": "c254",
    "IU": "c255",
    "IV": "c256",
    "IW": "c257",
    "IX": "c258",
    "IY": "c259",
    "IZ": "c260",
    "JA": "c261",
    "JB": "c262",
    "JC": "c263",
    "JD": "c264",
    "JE": "c265",
    "JF": "c266",
    "JG": "c267",
    "JH": "c268",
    "JI": "c269",
    "JJ": "c270",
    "JK": "c271",
    "JL": "c272",
    "JM": "c273",
    "JN": "c274",
    "JO": "c275",
    "JP": "c276",
    "JQ": "c277",
    "JR": "c278",
    "JS": "c279",
    "JT": "c280",
    "JU": "c281",
    "JV": "c282",
    "JW": "c283",
    "JX": "c284",
    "JY": "c285",
    "JZ": "c286",
    "KA": "c287",
    "KB": "c288",
    "KC": "c289",
    "KD": "c290",
    "KE": "c291",
    "KF": "c292",
    "KG": "c293",
    "KH": "c294",
    "KI": "c295",
    "KJ": "c296",
    "KK": "c297",
    "KL": "c298",
    "KM": "c299",
    "KN": "c300",
    "KO": "c301",
    "KP": "c302",
    "KQ": "c303",
    "KR": "c304",
    "KS": "c305",
    "KT": "c306",
    "KU": "c307",
    "KV": "c308",
    "KW": "c309",
    "KX": "c310",
    "KY": "c311",
    "KZ": "c312",
    "LA": "c313",
    "LB": "c314",
    "LC": "c315",
    "LD": "c316",
    "LE": "c317",
    "LF": "c318",
    "LG": "c319",
    "LH": "c320",
    "LI": "c321",
    "LJ": "c322",
    "LK": "c323",
    "LL": "c324",
    "LM": "c325",
    "LN": "c326",
    "LO": "c327",
    "LP": "c328",
    "LQ": "c329",
    "LR": "c330",
    "LS": "c331",
    "LT": "c332",
    "LU": "c333",
    "LV": "c334",
    "LW": "c335",
    "LX": "c336",
    "LY": "c337",
    "LZ": "c338",
    "MA": "c339",
    "MB": "c340",
    "MC": "c341",
    "MD": "c342",
    "ME": "c343",
    "MF": "c344",
    "MG": "c345",
    "MH": "c346",
    "MI": "c347",
    "MJ": "c348",
    "MK": "c349",
    "ML": "c350"
}

# 需要使用昨天的数据的表
yesterday_columns = {
    "F",
    "H",
    "J",
    "AC",
    "BD",
    "CE",
    "DF",
    "EG",
    "FH",
    "GI",
    "HJ",
    "IK",
    "JL",
    "LJ",
    "LS",
    "LT",
    "MA",
    "MB",
}

# 公式表
alg_map = {
    "c3": "=SUM(AL5,BM5,CN5,DO5,EP5,FQ5,GR5,HS5,IT5,JU5,LJ5,LR5,LS5,MX5,ME5)",
    "c4": "=C5/B5",
    "c5": "=(LU5+LB5)/B5",
    "c6": "=(AC5+BD5+CE5+DF5+EG5+FH5+GI5+HJ5+IK5+JL5)/B5",
    "c7": "=SUM(AL5,BM5,CN5,DO5,EP5,FQ5,GR5,HS5,IT5,JU5)",
    "c8": "=LJ5+LS5+ME5",
    "c9": "=LR5+MX5",
    "c10": "=MA5",
    "c11": "=E5+F5",
    "c14": "=Y5+AL5",
    "c15": "=N5/L5",
    "c24": "=Y5/T5",
    "c25": "=(P5/1000)*MA5",
    "c30": "=AB5/AC5",
    "c33": "=AC5/L5",
    "c41": "=AZ5+BM5",
    "c42": "=AO5/AM5",
    "c51": "=AZ5/AU5",
    "c52": "=(AQ5/1000)*MA5",
    "c57": "=BC5/BD5",
    "c60": "=BD5/AM5",
    "c67": "=(BN5-BN7)/BN7",
    "c68": "=CA5+CN5",
    "c69": "=BP5/BN5",
    "c78": "=CA5/BV5",
    "c79": "=(BR5/1000)*MA5",
    "c84": "=CD5/CE5",
    "c87": "=CE5/BN5",
    "c90": "=CH5/CD5",
    "c91": "=CN5/CH5",
    "c95": "=DB5+DO5",
    "c96": "=CQ5/CO5",
    "c105": "=DB5/CW5",
    "c106": "=(CS5/1000)*MA5",
    "c111": "=DE5/DF5",
    "c114": "=DF5/CO5",
    "c122": "=EC5+EP5",
    "c123": "=DR5/DP5",
    "c132": "=EC5/DX5",
    "c133": "=(DT5/1000)*MA5",
    "c138": "=EF5/EG5",
    "c141": "=EG5/DP5",
    "c149": "=FD5+FQ5",
    "c150": "=ES5/EQ5",
    "c165": "=FG5/FH5",
    "c168": "=FH5/EQ5",
    "c176": "=GE5+GR5",
    "c177": "=FT5/FR5",
    "c186": "=GE5/FZ5",
    "c187": "=(FV5/1000)*MA5",
    "c192": "=GH5/GI5",
    "c195": "=GI5/FR5",
    "c203": "=HF5+HS5",
    "c204": "=GU5/GS5",
    "c213": "=HF5/HA5",
    "c214": "=(GW5/1000)*MA5",
    "c219": "=HI5/HJ5",
    "c222": "=HJ5/GS5",
    "c230": "=IG5+IT5",
    "c231": "=HV5/HT5",
    "c240": "=IG5/IB5",
    "c241": "=(HX5/1000)*MA5",
    "c246": "=IJ5/IK5",
    "c249": "=IK5/HT5",
    "c257": "=JH5+JU5",
    "c258": "=IW5/IU5",
    "c267": "=JH5/JC5",
    "c268": "=(IY5/1000)*MA5",
    "c273": "=JK5/JL5",
    "c276": "=JL5/IU5",
    "c311": "=LJ5+LR5",
    "c312": "=KY5/KW5",
    "c321": "=LJ5/LE5",
    "c333": "=SUM(Q5,AR5,BS5,CT5,DU5,FW5,GX5,HY5,IZ5)",
    "c334": "=SUM(P5,AQ5,BR5,CS5,DT5,FV5,GW5,HX5,IY5)",
    "c335": "=LU5/(LU5+AC5+BD5+CE5+DF5+EG5+FH5+GI5+HJ5+IK5+JL5+LL5)",
    "c336": "=LS5-(LV5/1000*MC5)",
    "c337": "=SUM(T5,AU5,BV5,CW5,DX5,FC5,FZ5,HA5,IB5,JC5,LE5)",
    "c338": "=H5/LY5",
    "c341": "=(AB5*AI5+BC5*BJ5+CD5*CK5+DE5*DL5+EF5*EM5+FG5*FN5+GH5*GO5+HI5*HP5+IJ5*IQ5+JK5*JR5)/(AB5+BC5+CD5+DE5+EF5+FG5+GH5+HI5+IJ5+JK5)",
    "c342": "=(MA5-MC5)/MC5"
}